using System;
using System.IO;
using System.Runtime.InteropServices;
using System.Threading;
using System.Windows.Forms;

namespace DASpeaker {
    /// <summary>
    /// Summary description for Form1.
    /// </summary>
    public class DASpeakerForm : System.Windows.Forms.Form {
        private System.Windows.Forms.NotifyIcon DASpeakerSysTray;
        private System.Windows.Forms.ContextMenu DASpeakerContextMenu;
        private System.Windows.Forms.MenuItem menuItem1;
        private System.Windows.Forms.MenuItem menuItem2;
        private System.Windows.Forms.MenuItem menuItem3;
        private System.Windows.Forms.MenuItem menuItem4;
        private System.Windows.Forms.MenuItem menuItem5;
        private System.Windows.Forms.MenuItem menuItem6;
        private System.Windows.Forms.MenuItem menuItem8;
        private System.Windows.Forms.MainMenu DASpeakerMainMenu;
        private System.Windows.Forms.MenuItem menuItem9;
        private System.Windows.Forms.MenuItem menuItem10;
        private System.Windows.Forms.MenuItem menuItem11;
        private System.Windows.Forms.MenuItem menuItem12;
        private System.Windows.Forms.MenuItem menuItem13;
        private System.Windows.Forms.MenuItem menuItem14;
        private System.Windows.Forms.Label label1;
        private System.Windows.Forms.Label label2;
        private System.Windows.Forms.Label label3;
        private System.ComponentModel.IContainer components;
        private System.Windows.Forms.RichTextBox MainRichTextBox;
        private System.Windows.Forms.GroupBox groupBox1;
        private System.Windows.Forms.Button OpenFileBtn;
        private System.Windows.Forms.GroupBox groupBox2;
        private System.Windows.Forms.Label label4;
        private System.Windows.Forms.Label label5;
        private System.Windows.Forms.TextBox textBox1;
        private System.Windows.Forms.Label label6;
        private System.Windows.Forms.Button FormateTextBtn;
        private System.Windows.Forms.CheckBox BeepCheckBox;
        private System.Windows.Forms.Label label7;

        private HelBoxForm StartHelp = new HelBoxForm();
        private System.Windows.Forms.Timer DASpeakerTimer;

        string[] textSpeak;
        bool Beeper = true;
        int counter = 0;
        IntPtr DarkageshWnd = System.IntPtr.Zero;
        ushort StartHotKey = 0;
        ushort StopHotKey = 0;
        private MenuItem menuItem7;
        bool CleanedHotKeys = false;

        /*BOOL RegisterHotKey(
            HWND hWnd,
            int id,
            UINT fsModifiers,
            UINT vk
        );*/
        [DllImport("user32.dll")]
        [return: MarshalAs(UnmanagedType.Bool)]
        private static extern bool RegisterHotKey(IntPtr hWnd, int id, uint fsModifiers, uint vk);
        /*BOOL UnregisterHotKey(
            HWND hWnd,
            int id
        );*/
        [DllImport("user32.dll")]
        [return: MarshalAs(UnmanagedType.Bool)]
        private static extern bool UnregisterHotKey(IntPtr hWnd, int id);
        /*ATOM GlobalAddAtom(
            LPCTSTR lpString
        );*/
        [DllImport("kernel32")]
        private static extern ushort GlobalAddAtom(string lpString);
        /*ATOM GlobalDeleteAtom(
            ATOM nAtom
        );*/
        [DllImport("kernel32")]
        private static extern ushort GlobalDeleteAtom(ushort nAtom);
        /*BOOL PostMessage(
            HWND hWnd,
            UINT Msg,
            WPARAM wParam,
            LPARAM lParam
        );*/
        [DllImport("user32.dll")]
        [return: MarshalAs(UnmanagedType.Bool)]
        private static extern bool PostMessage(IntPtr hWnd, uint Msg, UIntPtr wParam, UIntPtr lParam);


        public DASpeakerForm() {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();
            DASpeakerSysTray.Icon = DASpeaker.Properties.Resources.Wizard1_S;
            this.Text = "DASpeaker v" + Application.ProductVersion;

            //
            // TODO: Add any constructor code after InitializeComponent call
            //
        }

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        protected override void Dispose(bool disposing) {
            UnregisterHotKey(this.Handle, 200);
            UnregisterHotKey(this.Handle, 201);

            if(disposing) {
                if(components != null) {
                    components.Dispose();
                }
            }
            base.Dispose(disposing);
        }

        #region Windows Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent() {
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(DASpeakerForm));
            this.DASpeakerSysTray = new System.Windows.Forms.NotifyIcon(this.components);
            this.DASpeakerContextMenu = new System.Windows.Forms.ContextMenu();
            this.menuItem5 = new System.Windows.Forms.MenuItem();
            this.menuItem6 = new System.Windows.Forms.MenuItem();
            this.menuItem8 = new System.Windows.Forms.MenuItem();
            this.menuItem3 = new System.Windows.Forms.MenuItem();
            this.menuItem4 = new System.Windows.Forms.MenuItem();
            this.menuItem2 = new System.Windows.Forms.MenuItem();
            this.menuItem1 = new System.Windows.Forms.MenuItem();
            this.DASpeakerMainMenu = new System.Windows.Forms.MainMenu(this.components);
            this.menuItem9 = new System.Windows.Forms.MenuItem();
            this.menuItem12 = new System.Windows.Forms.MenuItem();
            this.menuItem14 = new System.Windows.Forms.MenuItem();
            this.menuItem13 = new System.Windows.Forms.MenuItem();
            this.menuItem10 = new System.Windows.Forms.MenuItem();
            this.menuItem7 = new System.Windows.Forms.MenuItem();
            this.menuItem11 = new System.Windows.Forms.MenuItem();
            this.label1 = new System.Windows.Forms.Label();
            this.label2 = new System.Windows.Forms.Label();
            this.label3 = new System.Windows.Forms.Label();
            this.MainRichTextBox = new System.Windows.Forms.RichTextBox();
            this.groupBox1 = new System.Windows.Forms.GroupBox();
            this.OpenFileBtn = new System.Windows.Forms.Button();
            this.groupBox2 = new System.Windows.Forms.GroupBox();
            this.label5 = new System.Windows.Forms.Label();
            this.label4 = new System.Windows.Forms.Label();
            this.textBox1 = new System.Windows.Forms.TextBox();
            this.label6 = new System.Windows.Forms.Label();
            this.FormateTextBtn = new System.Windows.Forms.Button();
            this.DASpeakerTimer = new System.Windows.Forms.Timer(this.components);
            this.BeepCheckBox = new System.Windows.Forms.CheckBox();
            this.label7 = new System.Windows.Forms.Label();
            this.groupBox1.SuspendLayout();
            this.groupBox2.SuspendLayout();
            this.SuspendLayout();
            // 
            // DASpeakerSysTray
            // 
            this.DASpeakerSysTray.ContextMenu = this.DASpeakerContextMenu;
            this.DASpeakerSysTray.Text = "DASpeaker";
            this.DASpeakerSysTray.Visible = true;
            this.DASpeakerSysTray.DoubleClick += new System.EventHandler(this.SystemTray_DoubleClick);
            // 
            // DASpeakerContextMenu
            // 
            this.DASpeakerContextMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.menuItem5,
            this.menuItem6,
            this.menuItem8,
            this.menuItem3,
            this.menuItem4,
            this.menuItem2,
            this.menuItem1});
            // 
            // menuItem5
            // 
            this.menuItem5.Index = 0;
            this.menuItem5.Shortcut = System.Windows.Forms.Shortcut.ShiftIns;
            this.menuItem5.Text = "Start Speaking";
            this.menuItem5.Click += new System.EventHandler(this.button1_Click);
            // 
            // menuItem6
            // 
            this.menuItem6.Index = 1;
            this.menuItem6.Shortcut = System.Windows.Forms.Shortcut.ShiftDel;
            this.menuItem6.Text = "Stop Speaking";
            this.menuItem6.Click += new System.EventHandler(this.button2_Click);
            // 
            // menuItem8
            // 
            this.menuItem8.Index = 2;
            this.menuItem8.Text = "-";
            // 
            // menuItem3
            // 
            this.menuItem3.DefaultItem = true;
            this.menuItem3.Index = 3;
            this.menuItem3.Text = "DA-Speaker";
            this.menuItem3.Click += new System.EventHandler(this.SystemTray_DoubleClick);
            // 
            // menuItem4
            // 
            this.menuItem4.Index = 4;
            this.menuItem4.Text = "-";
            // 
            // menuItem2
            // 
            this.menuItem2.Index = 5;
            this.menuItem2.Text = "Help";
            this.menuItem2.Click += new System.EventHandler(this.menuItem11_Click);
            // 
            // menuItem1
            // 
            this.menuItem1.Index = 6;
            this.menuItem1.Text = "Exit";
            this.menuItem1.Click += new System.EventHandler(this.menuItem13_Click);
            // 
            // DASpeakerMainMenu
            // 
            this.DASpeakerMainMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.menuItem9,
            this.menuItem10});
            // 
            // menuItem9
            // 
            this.menuItem9.Index = 0;
            this.menuItem9.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.menuItem12,
            this.menuItem14,
            this.menuItem13});
            this.menuItem9.Text = "File";
            // 
            // menuItem12
            // 
            this.menuItem12.Index = 0;
            this.menuItem12.Text = "Open File...";
            this.menuItem12.Click += new System.EventHandler(this.button3_Click);
            // 
            // menuItem14
            // 
            this.menuItem14.Index = 1;
            this.menuItem14.Text = "-";
            // 
            // menuItem13
            // 
            this.menuItem13.Index = 2;
            this.menuItem13.Text = "Exit";
            this.menuItem13.Click += new System.EventHandler(this.menuItem13_Click);
            // 
            // menuItem10
            // 
            this.menuItem10.Index = 1;
            this.menuItem10.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.menuItem7,
            this.menuItem11});
            this.menuItem10.Text = "Help";
            // 
            // menuItem7
            // 
            this.menuItem7.Index = 0;
            this.menuItem7.Text = "Total Speak Time";
            this.menuItem7.Click += new System.EventHandler(this.menuItem7_Click);
            // 
            // menuItem11
            // 
            this.menuItem11.Index = 1;
            this.menuItem11.Text = "About";
            this.menuItem11.Click += new System.EventHandler(this.menuItem11_Click);
            // 
            // label1
            // 
            this.label1.Location = new System.Drawing.Point(8, 8);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(64, 16);
            this.label1.TabIndex = 2;
            this.label1.Text = "HotKeys:";
            // 
            // label2
            // 
            this.label2.Location = new System.Drawing.Point(24, 24);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(80, 16);
            this.label2.TabIndex = 3;
            this.label2.Text = "Start: Shift-Ins";
            // 
            // label3
            // 
            this.label3.Location = new System.Drawing.Point(24, 40);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(80, 16);
            this.label3.TabIndex = 4;
            this.label3.Text = "Stop: Shift-Del";
            // 
            // MainRichTextBox
            // 
            this.MainRichTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
                        | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.MainRichTextBox.Location = new System.Drawing.Point(8, 0);
            this.MainRichTextBox.Name = "MainRichTextBox";
            this.MainRichTextBox.ScrollBars = System.Windows.Forms.RichTextBoxScrollBars.ForcedVertical;
            this.MainRichTextBox.Size = new System.Drawing.Size(360, 386);
            this.MainRichTextBox.TabIndex = 6;
            this.MainRichTextBox.Text = "";
            // 
            // groupBox1
            // 
            this.groupBox1.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
            this.groupBox1.Controls.Add(this.label1);
            this.groupBox1.Controls.Add(this.label2);
            this.groupBox1.Controls.Add(this.label3);
            this.groupBox1.Location = new System.Drawing.Point(376, 242);
            this.groupBox1.Name = "groupBox1";
            this.groupBox1.Size = new System.Drawing.Size(120, 64);
            this.groupBox1.TabIndex = 7;
            this.groupBox1.TabStop = false;
            // 
            // OpenFileBtn
            // 
            this.OpenFileBtn.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
            this.OpenFileBtn.Location = new System.Drawing.Point(376, 316);
            this.OpenFileBtn.Name = "OpenFileBtn";
            this.OpenFileBtn.Size = new System.Drawing.Size(120, 32);
            this.OpenFileBtn.TabIndex = 8;
            this.OpenFileBtn.Text = "Open File...";
            this.OpenFileBtn.Click += new System.EventHandler(this.button3_Click);
            // 
            // groupBox2
            // 
            this.groupBox2.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
            this.groupBox2.Controls.Add(this.label5);
            this.groupBox2.Controls.Add(this.label4);
            this.groupBox2.Location = new System.Drawing.Point(376, 2);
            this.groupBox2.Name = "groupBox2";
            this.groupBox2.Size = new System.Drawing.Size(128, 182);
            this.groupBox2.TabIndex = 9;
            this.groupBox2.TabStop = false;
            // 
            // label5
            // 
            this.label5.Location = new System.Drawing.Point(8, 8);
            this.label5.Name = "label5";
            this.label5.Size = new System.Drawing.Size(64, 16);
            this.label5.TabIndex = 3;
            this.label5.Text = "Instructions:";
            // 
            // label4
            // 
            this.label4.Location = new System.Drawing.Point(8, 24);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(112, 152);
            this.label4.TabIndex = 2;
            this.label4.Text = resources.GetString("label4.Text");
            // 
            // textBox1
            // 
            this.textBox1.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
            this.textBox1.Location = new System.Drawing.Point(464, 194);
            this.textBox1.Name = "textBox1";
            this.textBox1.Size = new System.Drawing.Size(32, 20);
            this.textBox1.TabIndex = 10;
            this.textBox1.Text = "1.5";
            this.textBox1.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
            // 
            // label6
            // 
            this.label6.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
            this.label6.Location = new System.Drawing.Point(384, 194);
            this.label6.Name = "label6";
            this.label6.Size = new System.Drawing.Size(80, 16);
            this.label6.TabIndex = 11;
            this.label6.Text = "Secs per Line:";
            this.label6.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            // 
            // FormateTextBtn
            // 
            this.FormateTextBtn.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
            this.FormateTextBtn.Location = new System.Drawing.Point(376, 356);
            this.FormateTextBtn.Name = "FormateTextBtn";
            this.FormateTextBtn.Size = new System.Drawing.Size(120, 32);
            this.FormateTextBtn.TabIndex = 12;
            this.FormateTextBtn.Text = "Format Text";
            this.FormateTextBtn.Click += new System.EventHandler(this.button1_Click_1);
            // 
            // DASpeakerTimer
            // 
            this.DASpeakerTimer.Interval = 2500;
            this.DASpeakerTimer.Tick += new System.EventHandler(this.timer1_Tick);
            // 
            // BeepCheckBox
            // 
            this.BeepCheckBox.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
            this.BeepCheckBox.Checked = true;
            this.BeepCheckBox.CheckState = System.Windows.Forms.CheckState.Checked;
            this.BeepCheckBox.Location = new System.Drawing.Point(376, 218);
            this.BeepCheckBox.Name = "BeepCheckBox";
            this.BeepCheckBox.Size = new System.Drawing.Size(120, 18);
            this.BeepCheckBox.TabIndex = 13;
            this.BeepCheckBox.Text = "Beep when Stop";
            this.BeepCheckBox.CheckedChanged += new System.EventHandler(this.checkBox1_CheckedChanged);
            // 
            // label7
            // 
            this.label7.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
            this.label7.Font = new System.Drawing.Font("Microsoft Sans Serif", 7F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label7.Location = new System.Drawing.Point(8, 392);
            this.label7.Name = "label7";
            this.label7.Size = new System.Drawing.Size(486, 15);
            this.label7.TabIndex = 14;
            this.label7.Text = "Please Note: For Reliable Message Sending 0.95 sec/line is bare min (I would just" +
                " go for 1 sec/line)";
            // 
            // DASpeakerForm
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(506, 407);
            this.Controls.Add(this.label7);
            this.Controls.Add(this.BeepCheckBox);
            this.Controls.Add(this.textBox1);
            this.Controls.Add(this.FormateTextBtn);
            this.Controls.Add(this.label6);
            this.Controls.Add(this.groupBox2);
            this.Controls.Add(this.OpenFileBtn);
            this.Controls.Add(this.groupBox1);
            this.Controls.Add(this.MainRichTextBox);
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.Menu = this.DASpeakerMainMenu;
            this.Name = "DASpeakerForm";
            this.Resize += new System.EventHandler(this.Form1_Resize);
            this.Closing += new System.ComponentModel.CancelEventHandler(this.Form1_Closing);
            this.Load += new System.EventHandler(this.Form1_Load);
            this.groupBox1.ResumeLayout(false);
            this.groupBox2.ResumeLayout(false);
            this.ResumeLayout(false);
            this.PerformLayout();

        }
        #endregion

        [STAThread]
        static void Main() {
            if(System.Diagnostics.Process.GetProcessesByName("DASpeaker").Length == 2) return;
            AppDomain.CurrentDomain.UnhandledException += new UnhandledExceptionEventHandler(MyUnhandledEx);
            Application.ThreadException += new System.Threading.ThreadExceptionEventHandler(MyThreadingEx);

            Application.Run(new DASpeakerForm());
        }

        static void MyUnhandledEx(object sender, UnhandledExceptionEventArgs args) {
            using(System.IO.StreamWriter sw = new System.IO.StreamWriter("CrashLogUnhandledEx (DASpeaker " + Application.ProductVersion + ") " + DateTime.Now.ToString("u", System.Globalization.CultureInfo.InvariantCulture).TrimEnd('Z').Replace(":", "-") + ".txt", true)) sw.WriteLine(((Exception)args.ExceptionObject).ToString());
            Environment.Exit(0);
        }

        static void MyThreadingEx(object sender, ThreadExceptionEventArgs args) {
            using(System.IO.StreamWriter sw = new System.IO.StreamWriter("CrashLogThreadingEx (DASpeaker " + Application.ProductVersion + ") " + DateTime.Now.ToString("u", System.Globalization.CultureInfo.InvariantCulture).TrimEnd('Z').Replace(":", "-") + ".txt", true)) sw.WriteLine(args.Exception.ToString());
            Environment.Exit(0);
        }

        private void menuItem11_Click(object sender, System.EventArgs e) {
            StartHelp.Show();
        }

        private void menuItem13_Click(object sender, System.EventArgs e) {
            Application.Exit();
        }

        private void button3_Click(object sender, System.EventArgs e) {
            OpenFileDialog openFileDialog1 = new OpenFileDialog();

            openFileDialog1.Filter = "txt files (*.txt)|*.txt|All files (*.*)|*.*";
            openFileDialog1.FilterIndex = 1;
            openFileDialog1.InitialDirectory = Application.StartupPath;
            openFileDialog1.RestoreDirectory = true;

            if(openFileDialog1.ShowDialog() == DialogResult.OK) {
                StreamReader OpenFile = File.OpenText(openFileDialog1.FileName);

                MainRichTextBox.Text = OpenFile.ReadToEnd();
                OpenFile.Close();
            }
        }

        private void Form1_Resize(object sender, System.EventArgs e) {
            if(this.WindowState == FormWindowState.Minimized) {
                this.Hide();
            }
        }

        private void SystemTray_DoubleClick(object sender, System.EventArgs e) {
            this.Show();
            this.WindowState = FormWindowState.Normal;
        }

        //Start Speaking
        private System.Diagnostics.Process[] myProcesses;
        private void button1_Click(object sender, System.EventArgs e) {
            DASpeakerSysTray.Icon = DASpeaker.Properties.Resources.Wizard1_S_R;
            this.button1_Click_1(null, null);
            DASpeakerTimer.Interval = (int)(Convert.ToDouble(textBox1.Text) * 1000);
            if(DASpeakerTimer.Interval < 250) {
                DASpeakerTimer.Interval = 250;
                textBox1.Text = "0.25";
            }
            textSpeak = MainRichTextBox.Text.Split('\n');

            myProcesses = System.Diagnostics.Process.GetProcessesByName("Darkages");
            if(myProcesses.Length == 0) {
                MessageBox.Show("Can't Find Darkages Window");
                return;
            }

            DarkageshWnd = myProcesses[0].MainWindowHandle;

            DASpeakerTimer.Enabled = true;
        }

        //Stop Speaking
        private void button2_Click(object sender, System.EventArgs e) {
            DASpeakerSysTray.Icon = DASpeaker.Properties.Resources.Wizard1_S;
            DASpeakerTimer.Enabled = false;
            if(Beeper) System.Console.Beep(600, 250);
        }

        //Format Text
        private void button1_Click_1(object sender, System.EventArgs e) {
            string answer = "";
            string temp = "";
            string temp2 = "";
            string[] splitLine = MainRichTextBox.Text.Split('\n');
            string[] splitWord;
            int i = 0;
            int i2 = 0;

            while(i < splitLine.Length) {
                if(splitLine[i] == "") i++;
                else {
                    splitWord = splitLine[i].Split(' ');
                    temp = "";
                    i2 = 0;
                    while(i2 < splitWord.Length) {
                        temp2 = temp + splitWord[i2];
                        if(temp2.Length > 55) {
                            answer = answer + temp.Substring(0, temp.Length - 1) + "\n";
                            temp = "";
                        }
                        if(i2 + 1 == splitWord.Length) temp = temp + splitWord[i2];
                        else temp = temp + splitWord[i2] + " ";
                        i2++;
                    }
                    if(i + 1 == splitLine.Length) answer = answer + temp;
                    else answer = answer + temp + "\n";
                    i++;
                }
            }
            MainRichTextBox.Text = answer;
        }

        private void timer1_Tick(object sender, System.EventArgs e) {
            if(counter == textSpeak.Length) {
                DASpeakerTimer.Enabled = false;
                counter = 0;
                DASpeakerSysTray.Icon = DASpeaker.Properties.Resources.Wizard1_S;
                if(Beeper) System.Console.Beep(600, 250);
            } else {
                string temp = textSpeak[counter];
                char[] temp2 = temp.ToCharArray();
                int i = 0;

                PostMessage(DarkageshWnd, 0x0102, (UIntPtr)Keys.Enter, (UIntPtr)0);

                Thread.Sleep(100);

                while(i < temp2.Length) {
                    PostMessage(DarkageshWnd, 0x0102, (UIntPtr)temp2[i], (UIntPtr)0);
                    i++;
                }

                PostMessage(DarkageshWnd, 0x0102, (UIntPtr)Keys.Enter, (UIntPtr)0);

                counter++;
            }
        }

        private void checkBox1_CheckedChanged(object sender, System.EventArgs e) {
            Beeper = !Beeper;
        }

        // WM_HOTKEY = 0x312;
        protected override void WndProc(ref Message m) {
            if(m.Msg == 0x312) {
                if((ushort)m.WParam == StartHotKey) this.button1_Click(null, null);
                else if((ushort)m.WParam == StopHotKey) this.button2_Click(null, null);
            }
            base.WndProc(ref m);
        }

        private void Form1_Closing(object sender, System.ComponentModel.CancelEventArgs e) {
            if(!CleanedHotKeys) {
                UnregisterHotKey(this.Handle, StartHotKey);
                UnregisterHotKey(this.Handle, StopHotKey);
                GlobalDeleteAtom(StartHotKey);
                GlobalDeleteAtom(StopHotKey);
            }
        }

        private void Form1_Load(object sender, System.EventArgs e) {
            StartHotKey = GlobalAddAtom("StartSearch_2000");
            StopHotKey = GlobalAddAtom("StopSearch_2001");
            if(StartHotKey == 0 || StopHotKey == 0) MessageBox.Show("Wasn't Able to Add Hotkey Atoms");
            else {
                // MOD_ALT = 0x1;	MOD_CONTROL = 0x2;	MOD_SHIFT = 0x4;	MOD_WIN = 0x8;
                bool Suc1 = RegisterHotKey(this.Handle, StartHotKey, 0x4, (int)Keys.Insert);
                bool Suc2 = RegisterHotKey(this.Handle, StopHotKey, 0x4, (int)Keys.Delete);
                if(!Suc2 || !Suc2) {
                    MessageBox.Show("Wasn't Able to Register Hotkeys!");
                    GlobalDeleteAtom(StartHotKey);
                    GlobalDeleteAtom(StopHotKey);
                    CleanedHotKeys = true;
                }
            }
        }

        private void menuItem7_Click(object sender, EventArgs e) {
            int counter = 0;
            foreach(char a in MainRichTextBox.Text) if(a == '\n') counter++;
            double secPerLine;
            if(double.TryParse(textBox1.Text, out secPerLine)) MessageBox.Show((counter * secPerLine).ToString() + " Total Seconds to Speak Entire Log (" + (counter * secPerLine / 60).ToString() + " Mins)");
        }
    }
}